image: docker:19.03.12

services:
  - name: docker:dind
    entrypoint: ["env", "-u", "DOCKER_HOST"]
    command: ["dockerd-entrypoint.sh"]

stages:
  - build
  - retag

variables:
  DOCKER_HOST: tcp://docker:2375/
  DOCKER_DRIVER: overlay2
  DOCKER_TLS_CERTDIR: ""
  IMAGE_ADDR: $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
  IMAGE_CACHE: $CI_REGISTRY_IMAGE/cache:$CI_COMMIT_SHA
  IMAGE_FINAL: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME

build:
  stage: build
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  script:
    - docker build -t $IMAGE_ADDR .
    - docker push $IMAGE_ADDR

retag:
  stage: retag
  image:
    name: quay.io/skopeo/stable
    entrypoint: [""]
  script:
    - >
        skopeo copy \
            --dest-creds=$CI_REGISTRY_USER:$CI_REGISTRY_PASSWORD \
            --src-creds=$CI_REGISTRY_USER:$CI_REGISTRY_PASSWORD \
            docker://$IMAGE_ADDR docker://$IMAGE_FINAL
